*** ./doc/src/sgml/rules.sgml.orig	2010-08-28 18:12:42.000000000 +0100
--- ./doc/src/sgml/rules.sgml	2010-08-31 14:02:45.000000000 +0100
***************
*** 168,176 ****
      <para>
          <command>DELETE</command> commands don't need a target list
          because they don't produce any result. In fact, the planner will
!         add a special <acronym>CTID</> entry to the empty target list, but
!         this is after the rule system and will be discussed later; for the
!         rule system, the target list is empty.
      </para>
  
      <para>
--- 168,178 ----
      <para>
          <command>DELETE</command> commands don't need a target list
          because they don't produce any result. In fact, the planner will
!         add a special <acronym>CTID</> entry to the empty target list (if the
!         result relation is a table), but this is after the rule system and
!         will be discussed later; for the rule system, the target list is empty.
!         If the result relation is a view, the rule system will behave slightly
!         differently, as described later.
      </para>
  
      <para>
***************
*** 189,198 ****
          For <command>UPDATE</command> commands, the target list
          describes the new rows that should replace the old ones. In the
          rule system, it contains just the expressions from the <literal>SET
!         column = expression</literal> part of the command.  The planner will handle
!         missing columns by inserting expressions that copy the values from
!         the old row into the new one. And it will add the special
!         <acronym>CTID</> entry just as for <command>DELETE</command>, too.
      </para>
  
      <para>
--- 191,202 ----
          For <command>UPDATE</command> commands, the target list
          describes the new rows that should replace the old ones. In the
          rule system, it contains just the expressions from the <literal>SET
!         column = expression</literal> part of the command.  The planner will
!         handle missing columns by inserting expressions that copy the values
!         from the old row into the new one. And it will add the special
!         <acronym>CTID</> entry, if the result relation is a table, just as
!         for <command>DELETE</command>. If the result relation is a view,
!         the rule system will behave slightly differently, as described later.
      </para>
  
      <para>
***************
*** 656,662 ****
  <para>
      Two details of the query tree aren't touched in the description of
      view rules above. These are the command type and the result relation.
!     In fact, view rules don't need this information.
  </para>
  
  <para>
--- 660,668 ----
  <para>
      Two details of the query tree aren't touched in the description of
      view rules above. These are the command type and the result relation.
!     In fact, the command type is not needed by view rules, but the result
!     relation may affect the way in which the query rewriter works, because
!     special care needs to be taken if the result relation is a view.
  </para>
  
  <para>
***************
*** 725,745 ****
  </programlisting>
      
      will do. But there is a little problem in
!     <command>UPDATE</command>: The executor does not care what the
!     results from the join it is doing are meant for. It just produces
!     a result set of rows. The difference that one is a
!     <command>SELECT</command> command and the other is an
!     <command>UPDATE</command> is handled in the caller of the
!     executor. The caller still knows (looking at the query tree) that
!     this is an <command>UPDATE</command>, and it knows that this
!     result should go into table <literal>t1</>. But which of the rows that are
!     there has to be replaced by the new row?
  </para>
  
  <para>
!     To resolve this problem, another entry is added to the target list
!     in <command>UPDATE</command> (and also in
!     <command>DELETE</command>) statements: the current tuple ID
      (<acronym>CTID</>).<indexterm><primary>CTID</></>
      This is a system column containing the
      file block number and position in the block for the row. Knowing
--- 731,750 ----
  </programlisting>
      
      will do. But there is a little problem in
!     <command>UPDATE</command>: The branch of the executor plan that does
!     the join does not care what the results from the join it is doing are
!     meant for. It just produces a result set of rows. The difference that
!     one is a <command>SELECT</command> command and the other is an
!     <command>UPDATE</command> is handled higher up in the executor, where
!     it knows that this is an <command>UPDATE</command>, and it knows that
!     this result should go into table <literal>t1</>. But which of the rows
!     that are there has to be replaced by the new row?
  </para>
  
  <para>
!     If the result relation is a table, this problem is resolved by adding
!     another entry to the target list in <command>UPDATE</command> (and
!     also in <command>DELETE</command>) statements: the current tuple ID
      (<acronym>CTID</>).<indexterm><primary>CTID</></>
      This is a system column containing the
      file block number and position in the block for the row. Knowing
***************
*** 764,770 ****
  
  <para>
      Knowing all that, we can simply apply view rules in absolutely
!     the same way to any command. There is no difference.
  </para>
  </sect2>
  
--- 769,777 ----
  
  <para>
      Knowing all that, we can simply apply view rules in absolutely
!     the same way to any command. There is no difference, unless the view is
!     the result relation, which must be handled differently (see
!     <xref linkend="rules-views-update">).
  </para>
  </sect2>
  
***************
*** 803,818 ****
  <para>
      What happens if a view is named as the target relation for an
      <command>INSERT</command>, <command>UPDATE</command>, or
!     <command>DELETE</command>?  After doing the substitutions
!     described above, we will have a query tree in which the result
!     relation points at a subquery range-table entry.  This will not
!     work, so the rewriter throws an error if it sees it has produced
!     such a thing.
  </para>
  
  <para>
!     To change this, we can define rules that modify the behavior of
!     these kinds of commands. This is the topic of the next section.
  </para>
  </sect2>
  
--- 810,859 ----
  <para>
      What happens if a view is named as the target relation for an
      <command>INSERT</command>, <command>UPDATE</command>, or
!     <command>DELETE</command>?  Simply doing the substitutions
!     described above would give a query tree in which the result
!     relation points at a subquery range-table entry, which would not
!     work.  The rewriter handles this case slightly differently, leaving
!     the original view range-table entry as the result relation, and for
!     <command>UPDATE</command> and <command>DELETE</command> operations,
!     adding a new subquery range-table entry based on the view's query.
  </para>
  
  <para>
!     Another problem that now arises is how to identify the rows to be
!     updated in the result relation. Recall that when the result relation
!     was a table, a special <acronym>CTID</> entry was added to the target
!     list to identify the physical locations of the rows to be updated.
!     This does not work if the result relation is a view, because a view
!     typically does not have a <acronym>CTID</>, and its rows may not have
!     unique physical locations. Instead, for an <command>UPDATE</command>
!     or <command>DELETE</command> operation, a special <literal>wholerow</>
!     entry is added to the target list, which expands to include all
!     columns from the view. The executor does not know how to update the
!     view; it relies on <literal>INSTEAD OF</> triggers for this. The
!     executor uses the <literal>wholerow</> target list entry to pass the
!     data from all the columns in the view to the triggers, to allow them
!     to work out what to update.
! </para>
! 
! <para>
!     If there are no <literal>INSTEAD OF</> triggers to update the view,
!     the executor will throw an error, because it cannot automatically
!     update a view by itself. To change this, we can define rules that
!     modify the behavior of <command>INSERT</command>,
!     <command>UPDATE</command>, and <command>DELETE</command> commands on
!     a view. These rules will rewrite the command, typically into a command
!     that updates one or more tables, rather than views. This is the topic
!     of the next section.
! </para>
! 
! <para>
!     Note that rules are evaluated first, rewriting the original query
!     before it is planned and executed. Therefore, if a view has
!     <literal>INSTEAD OF</> triggers as well as rules on <command>INSERT</>,
!     <command>UPDATE</>, and <command>DELETE</>, then the rules will be
!     evaluated first, and depending on the result, the triggers may not be
!     used at all.
  </para>
  </sect2>
  
***************
*** 1868,1876 ****
  </para>
  
  <para>
!     On the other hand, a trigger cannot be created on views because
!     there is no real data in a view relation;  however INSERT, UPDATE,
!     and DELETE rules can be created on views.
  </para>
  
  <para>
--- 1909,1923 ----
  </para>
  
  <para>
!     In this chapter, we focused on using rules to update views. All of
!     the update rule examples in this chapter can also be implemented
!     using <literal>INSTEAD OF</> triggers on the views (triggers defined
!     to fire instead of the view update operations, with trigger functions
!     that do the <command>INSERT</>, <command>UPDATE</> and
!     <command>DELETE</> operations on the base tables). Writing such
!     triggers is often easier than writing rules, particularly if complex
!     logic is required to perform the update, however, it is possible that
!     for bulk update operations, rules may perform better than triggers.
  </para>
  
  <para>
*** ./doc/src/sgml/trigger.sgml.orig	2010-08-28 18:09:13.000000000 +0100
--- ./doc/src/sgml/trigger.sgml	2010-09-07 21:06:24.000000000 +0100
***************
*** 33,39 ****
     <para>
      A trigger is a specification that the database should automatically
      execute a particular function whenever a certain type of operation is
!     performed.  Triggers can be defined to execute either before or after any
      <command>INSERT</command>, <command>UPDATE</command>, or
      <command>DELETE</command> operation, either once per modified row,
      or once per <acronym>SQL</acronym> statement.
--- 33,43 ----
     <para>
      A trigger is a specification that the database should automatically
      execute a particular function whenever a certain type of operation is
!     performed.
!   </para>
! 
!   <para>
!     On tables, triggers can be defined to execute either before or after any
      <command>INSERT</command>, <command>UPDATE</command>, or
      <command>DELETE</command> operation, either once per modified row,
      or once per <acronym>SQL</acronym> statement.
***************
*** 46,51 ****
--- 50,68 ----
     </para>
  
     <para>
+     On views, triggers can be defined to execute instead of
+     <command>INSERT</command>, <command>UPDATE</command>, or
+     <command>DELETE</command> operations, and are fired once per row that
+     needs to be modified in the view.  It is the responsibility of the
+     trigger's function to perform the necessary modifications to the
+     underlying base tables and, where appropriate, return the modified
+     row as it appears in the view.  Triggers can also be defined to
+     execute once per <acronym>SQL</acronym> statement, before or after
+     <command>INSERT</command>, <command>UPDATE</command>, or
+     <command>DELETE</command> operations.
+    </para>
+ 
+    <para>
      The trigger function must be defined before the trigger itself can be
      created.  The trigger function must be declared as a
      function taking no arguments and returning type <literal>trigger</>.
***************
*** 74,91 ****
      two types of triggers are sometimes called <firstterm>row-level</>
      triggers and <firstterm>statement-level</> triggers,
      respectively. Triggers on <command>TRUNCATE</command> may only be
!     defined at statement-level.
     </para>
  
     <para>
!     Triggers are also classified as <firstterm>before</> triggers and
!     <firstterm>after</> triggers.
!     Statement-level before triggers naturally fire before the
!     statement starts to do anything, while statement-level after
!     triggers fire at the very end of the statement.  Row-level before
      triggers fire immediately before a particular row is operated on,
!     while row-level after triggers fire at the end of the statement
!     (but before any statement-level after triggers).
     </para>
  
     <para>
--- 91,120 ----
      two types of triggers are sometimes called <firstterm>row-level</>
      triggers and <firstterm>statement-level</> triggers,
      respectively. Triggers on <command>TRUNCATE</command> may only be
!     defined at statement-level.  On views, triggers that fire before or
!     after may only be defined at statement-level, and triggers that fire
!     instead of an <command>INSERT</command>, <command>UPDATE</command>,
!     or <command>DELETE</command> may only be defined at row-level.
     </para>
  
     <para>
!     Triggers are also classified according to whether they fire
!     <firstterm>before</>, <firstterm>after</> or
!     <firstterm>instead of</> the operation. These are referred to
!     as <literal>BEFORE</> triggers, <literal>AFTER</> triggers and
!     <literal>INSTEAD OF</> triggers respectively.
!     Statement-level <literal>BEFORE</> triggers naturally fire before the
!     statement starts to do anything, while statement-level <literal>AFTER</>
!     triggers fire at the very end of the statement.  These types of
!     triggers may be defined on tables or views.  Row-level <literal>BEFORE</>
      triggers fire immediately before a particular row is operated on,
!     while row-level <literal>AFTER</> triggers fire at the end of the
!     statement (but before any statement-level <literal>AFTER</> triggers).
!     These types of triggers may only be defined on tables.  Row-level
!     <literal>INSTEAD OF</> triggers may only be defined on views, and fire
!     immediately as each row in the view is identified as needing to be
!     operated on (after any statement-level <literal>BEFORE</> triggers,
!     and before any statement-level <literal>AFTER</> triggers on the view).
     </para>
  
     <para>
***************
*** 117,124 ****
       </listitem>
      </itemizedlist>
  
!     A row-level before trigger that does not intend to cause either of
!     these behaviors must be careful to return as its result the same
      row that was passed in (that is, the <varname>NEW</varname> row
      for <command>INSERT</command> and <command>UPDATE</command>
      triggers, the <varname>OLD</varname> row for
--- 146,153 ----
       </listitem>
      </itemizedlist>
  
!     A row-level <literal>BEFORE</> trigger that does not intend to cause
!     either of these behaviors must be careful to return as its result the same
      row that was passed in (that is, the <varname>NEW</varname> row
      for <command>INSERT</command> and <command>UPDATE</command>
      triggers, the <varname>OLD</varname> row for
***************
*** 126,131 ****
--- 155,176 ----
     </para>
  
     <para>
+     A row-level <literal>INSTEAD OF</> trigger should either return
+     <symbol>NULL</> to indicate that it did not modify any data from
+     the view's underlying base tables, or it should return the view
+     row that was passed in (the <varname>NEW</varname> row
+     for <command>INSERT</command> and <command>UPDATE</command>
+     operations, or the <varname>OLD</varname> row for
+     <command>DELETE</command> operations). A nonnull return value is
+     used to signal that the trigger performed the necessary data
+     modifications in the view, and will cause the count of the number
+     of rows affected in the command status to be incremented. For
+     <command>INSERT</> and <command>UPDATE</> operations, the trigger
+     may modify the <varname>NEW</> row before returning it, to support
+     <command>INSERT RETURNING</> and <command>UPDATE RETURNING</>.
+    </para>
+ 
+    <para>
      The return value is ignored for row-level triggers fired after an
      operation, and so they can return <symbol>NULL</>.
     </para>
***************
*** 133,143 ****
     <para>
      If more than one trigger is defined for the same event on the same
      relation, the triggers will be fired in alphabetical order by
!     trigger name.  In the case of before triggers, the
!     possibly-modified row returned by each trigger becomes the input
!     to the next trigger.  If any before trigger returns
      <symbol>NULL</>, the operation is abandoned for that row and subsequent
!     triggers are not fired.
     </para>
  
     <para>
--- 178,189 ----
     <para>
      If more than one trigger is defined for the same event on the same
      relation, the triggers will be fired in alphabetical order by
!     trigger name.  In the case of <literal>BEFORE</> and
!     <literal>INSTEAD OF</> triggers, the possibly-modified row returned by
!     each trigger becomes the input to the next trigger.  If any
!     <literal>BEFORE</> or <literal>INSTEAD OF</> trigger returns
      <symbol>NULL</>, the operation is abandoned for that row and subsequent
!     triggers are not fired (for that row).
     </para>
  
     <para>
***************
*** 146,176 ****
      be fired.  In row-level triggers the <literal>WHEN</> condition can
      examine the old and/or new values of columns of the row.  (Statement-level
      triggers can also have <literal>WHEN</> conditions, although the feature
!     is not so useful for them.)  In a before trigger, the <literal>WHEN</>
      condition is evaluated just before the function is or would be executed,
      so using <literal>WHEN</> is not materially different from testing the
      same condition at the beginning of the trigger function.  However, in
!     an after trigger, the <literal>WHEN</> condition is evaluated just after
!     the row update occurs, and it determines whether an event is queued to
!     fire the trigger at the end of statement.  So when an after trigger's
      <literal>WHEN</> condition does not return true, it is not necessary
      to queue an event nor to re-fetch the row at end of statement.  This
      can result in significant speedups in statements that modify many
      rows, if the trigger only needs to be fired for a few of the rows.
     </para>
  
     <para>
!     Typically, row before triggers are used for checking or
      modifying the data that will be inserted or updated.  For example,
!     a before trigger might be used to insert the current time into a
      <type>timestamp</type> column, or to check that two elements of the row are
!     consistent. Row after triggers are most sensibly
      used to propagate the updates to other tables, or make consistency
      checks against other tables.  The reason for this division of labor is
!     that an after trigger can be certain it is seeing the final value of the
!     row, while a before trigger cannot; there might be other before triggers
!     firing after it.  If you have no specific reason to make a trigger before
!     or after, the before case is more efficient, since the information about
      the operation doesn't have to be saved until end of statement.
     </para>
  
--- 192,228 ----
      be fired.  In row-level triggers the <literal>WHEN</> condition can
      examine the old and/or new values of columns of the row.  (Statement-level
      triggers can also have <literal>WHEN</> conditions, although the feature
!     is not so useful for them.)  In a <literal>BEFORE</> trigger, the
!     <literal>WHEN</>
      condition is evaluated just before the function is or would be executed,
      so using <literal>WHEN</> is not materially different from testing the
      same condition at the beginning of the trigger function.  However, in
!     an <literal>AFTER</> trigger, the <literal>WHEN</> condition is evaluated
!     just after the row update occurs, and it determines whether an event is
!     queued to fire the trigger at the end of statement.  So when an
!     <literal>AFTER</> trigger's
      <literal>WHEN</> condition does not return true, it is not necessary
      to queue an event nor to re-fetch the row at end of statement.  This
      can result in significant speedups in statements that modify many
      rows, if the trigger only needs to be fired for a few of the rows.
+     <literal>INSTEAD OF</> triggers on views do not support
+     <literal>WHEN</> conditions.
     </para>
  
     <para>
!     Typically, row-level <literal>BEFORE</> triggers are used for checking or
      modifying the data that will be inserted or updated.  For example,
!     a <literal>BEFORE</> trigger might be used to insert the current time into a
      <type>timestamp</type> column, or to check that two elements of the row are
!     consistent. Row-level <literal>AFTER</> triggers are most sensibly
      used to propagate the updates to other tables, or make consistency
      checks against other tables.  The reason for this division of labor is
!     that an <literal>AFTER</> trigger can be certain it is seeing the final
!     value of the row, while a <literal>BEFORE</> trigger cannot; there might
!     be other <literal>BEFORE</> triggers firing after it.  If you have no
!     specific reason to make a trigger <literal>BEFORE</> or
!     <literal>AFTER</>, the <literal>BEFORE</> case is more efficient, since
!     the information about
      the operation doesn't have to be saved until end of statement.
     </para>
  
***************
*** 237,243 ****
         Statement-level triggers follow simple visibility rules: none of
         the changes made by a statement are visible to statement-level
         triggers that are invoked before the statement, whereas all
!        modifications are visible to statement-level after triggers.
        </para>
       </listitem>
  
--- 289,296 ----
         Statement-level triggers follow simple visibility rules: none of
         the changes made by a statement are visible to statement-level
         triggers that are invoked before the statement, whereas all
!        modifications are visible to statement-level <literal>AFTER</>
!        triggers.
        </para>
       </listitem>
  
***************
*** 245,258 ****
        <para>
         The data change (insertion, update, or deletion) causing the
         trigger to fire is naturally <emphasis>not</emphasis> visible
!        to SQL commands executed in a row-level before trigger, because
!        it hasn't happened yet.
        </para>
       </listitem>
  
       <listitem>
        <para>
!        However, SQL commands executed in a row-level before
         trigger <emphasis>will</emphasis> see the effects of data
         changes for rows previously processed in the same outer
         command.  This requires caution, since the ordering of these
--- 298,311 ----
        <para>
         The data change (insertion, update, or deletion) causing the
         trigger to fire is naturally <emphasis>not</emphasis> visible
!        to SQL commands executed in a row-level <literal>BEFORE</> trigger,
!        because it hasn't happened yet.
        </para>
       </listitem>
  
       <listitem>
        <para>
!        However, SQL commands executed in a row-level <literal>BEFORE</>
         trigger <emphasis>will</emphasis> see the effects of data
         changes for rows previously processed in the same outer
         command.  This requires caution, since the ordering of these
***************
*** 263,269 ****
  
       <listitem>
        <para>
!        When a row-level after trigger is fired, all data changes made
         by the outer command are already complete, and are visible to
         the invoked trigger function.
        </para>
--- 316,323 ----
  
       <listitem>
        <para>
!        When a row-level <literal>AFTER</> trigger is fired, all data
!        changes made
         by the outer command are already complete, and are visible to
         the invoked trigger function.
        </para>
***************
*** 376,381 ****
--- 430,444 ----
             </para>
            </listitem>
           </varlistentry>
+ 
+          <varlistentry>
+           <term><literal>TRIGGER_FIRED_INSTEAD(tg_event)</literal></term>
+           <listitem>
+            <para>
+             Returns true if the trigger fired instead of the operation.
+            </para>
+           </listitem>
+          </varlistentry>
  
           <varlistentry>
            <term><literal>TRIGGER_FIRED_AFTER(tg_event)</literal></term>
*** ./src/backend/catalog/index.c.orig	2010-08-14 23:52:07.000000000 +0100
--- ./src/backend/catalog/index.c	2010-08-15 09:53:21.000000000 +0100
***************
*** 825,830 ****
--- 825,831 ----
  				trigger->funcname = SystemFuncName("unique_key_recheck");
  				trigger->args = NIL;
  				trigger->before = false;
+ 				trigger->instead = false;
  				trigger->row = true;
  				trigger->events = TRIGGER_TYPE_INSERT | TRIGGER_TYPE_UPDATE;
  				trigger->columns = NIL;
*** ./src/backend/catalog/information_schema.sql.orig	2010-08-28 16:44:27.000000000 +0100
--- ./src/backend/catalog/information_schema.sql	2010-08-31 12:43:19.000000000 +0100
***************
*** 1937,1943 ****
               CASE WHEN t.tgtype & 1 = 1 THEN 'ROW' ELSE 'STATEMENT' END
               AS character_data) AS action_orientation,
             CAST(
!              CASE WHEN t.tgtype & 2 = 2 THEN 'BEFORE' ELSE 'AFTER' END
               AS character_data) AS condition_timing,
             CAST(null AS sql_identifier) AS condition_reference_old_table,
             CAST(null AS sql_identifier) AS condition_reference_new_table,
--- 1937,1943 ----
               CASE WHEN t.tgtype & 1 = 1 THEN 'ROW' ELSE 'STATEMENT' END
               AS character_data) AS action_orientation,
             CAST(
!              CASE WHEN t.tgtype & 2 = 2 THEN 'BEFORE' WHEN t.tgtype & 64 = 64 THEN 'INSTEAD OF' ELSE 'AFTER' END
               AS character_data) AS condition_timing,
             CAST(null AS sql_identifier) AS condition_reference_old_table,
             CAST(null AS sql_identifier) AS condition_reference_new_table,
***************
*** 2233,2241 ****
                    THEN 'YES' ELSE 'NO' END
               AS yes_or_no) AS is_insertable_into,
  
!            CAST('NO' AS yes_or_no) AS is_trigger_updatable,
!            CAST('NO' AS yes_or_no) AS is_trigger_deletable,
!            CAST('NO' AS yes_or_no) AS is_trigger_insertable_into
  
      FROM pg_namespace nc, pg_class c
  
--- 2233,2252 ----
                    THEN 'YES' ELSE 'NO' END
               AS yes_or_no) AS is_insertable_into,
  
!            CAST(
!              CASE WHEN EXISTS (SELECT 1 FROM pg_trigger WHERE tgrelid = c.oid AND tgtype & 80 = 80)
!                   THEN 'YES' ELSE 'NO' END
!            AS yes_or_no) AS is_trigger_updatable,
! 
!            CAST(
!              CASE WHEN EXISTS (SELECT 1 FROM pg_trigger WHERE tgrelid = c.oid AND tgtype & 72 = 72)
!                   THEN 'YES' ELSE 'NO' END
!            AS yes_or_no) AS is_trigger_deletable,
! 
!            CAST(
!              CASE WHEN EXISTS (SELECT 1 FROM pg_trigger WHERE tgrelid = c.oid AND tgtype & 68 = 68)
!                   THEN 'YES' ELSE 'NO' END
!            AS yes_or_no) AS is_trigger_insertable_into
  
      FROM pg_namespace nc, pg_class c
  
*** ./src/backend/commands/tablecmds.c.orig	2010-08-19 08:50:53.000000000 +0100
--- ./src/backend/commands/tablecmds.c	2010-08-19 08:50:52.000000000 +0100
***************
*** 5619,5624 ****
--- 5619,5625 ----
  	fk_trigger->trigname = "RI_ConstraintTrigger";
  	fk_trigger->relation = myRel;
  	fk_trigger->before = false;
+ 	fk_trigger->instead = false;
  	fk_trigger->row = true;
  
  	/* Either ON INSERT or ON UPDATE */
***************
*** 5682,5687 ****
--- 5683,5689 ----
  	fk_trigger->trigname = "RI_ConstraintTrigger";
  	fk_trigger->relation = fkconstraint->pktable;
  	fk_trigger->before = false;
+ 	fk_trigger->instead = false;
  	fk_trigger->row = true;
  	fk_trigger->events = TRIGGER_TYPE_DELETE;
  	fk_trigger->columns = NIL;
***************
*** 5735,5740 ****
--- 5737,5743 ----
  	fk_trigger->trigname = "RI_ConstraintTrigger";
  	fk_trigger->relation = fkconstraint->pktable;
  	fk_trigger->before = false;
+ 	fk_trigger->instead = false;
  	fk_trigger->row = true;
  	fk_trigger->events = TRIGGER_TYPE_UPDATE;
  	fk_trigger->columns = NIL;
